resource-website/main/urls.py
from django.contrib import admin
from django.urls import include, path
from django.conf import settings
from django.conf.urls.static import static
from django.contrib.auth.views import logout_then_login
from markdownx import urls as markdownx

urlpatterns = [
    path('', include('pages.urls')),
    path('', include('social_django.urls', namespace='social')),
    path('logout/', logout_then_login, {'login_url': settings.LOGIN_REDIRECT_URL}, name='logout'),
    path('user_management/', include('user_management.urls')),
    path('lockout/', include('lockout.urls')),
    path('loans/', include('loans.urls')),
    path('inventory/', include('inventory.urls')),
    path('tests/', include('tests.urls')),
    path('wiki/', include('wiki.urls')),
    path('worklog/', include('worklog.urls')),
    path('printcenter/', include('printcenter.urls')),
    path('trainings/', include('trainings.urls')),
    path('admin/', admin.site.urls),
    path('markdownx/', include(markdownx))
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

handler404 = 'pages.views.error_404'
handler500 = 'pages.views.error_500'
handler403 = 'pages.views.error_403'
handler400 = 'pages.views.error_400'

resource-website/trainings/urls.py
from django.urls import path

from . import views


urlpatterns = [
    path('', views.view_index, name='trainings'),
    path('certificate/<int:user_training_id>', views.view_certificate, name='certificate'),
    path('details/<int:training_id>', views.view_training_details, name='training_details'),
    path('tgdetails/', views.view_training_group_details, name='training_group_details'),

]

resource-website/trainings/models.py
from django.db import models
from django.conf import settings
from django.utils import timezone
from datetime import date

import logging

log = logging.getLogger(__name__)


def certificate_upload_to(certificate, filename):
    return 'uploads/trainings/certificates/{}/{}'.format(certificate.name, filename)


def certificate_image_upload_to(certificateimage, filename):
    return 'uploads/trainings/certificates/{}/images/{}'.format(certificateimage.certificate.name, filename)


class Certificate(models.Model):
    name = models.CharField(max_length=64, default="")
    html_template = models.FileField(upload_to=certificate_upload_to)

    def __str__(self):
        return "{} ({})".format(self.name, self.id)

    @property
    def template_url(self):
        return self.html_template.path


class CertificateImage(models.Model):
    image = models.ImageField(upload_to=certificate_image_upload_to)
    certificate = models.ForeignKey(Certificate, on_delete=models.CASCADE)


class Training(models.Model):
    title = models.CharField(max_length=64, default="")
    description = models.TextField(default="")
    certificate = models.ForeignKey(Certificate, on_delete=models.SET_NULL, null=True)

    def __str__(self):
        return self.title

    class Meta:
        permissions = (
            ('view_user_trainings', 'Can view user trainings'),
        )


class UserTraining(models.Model):
    training = models.ForeignKey(Training, on_delete=models.CASCADE)
    trainee = models.ForeignKey(settings.AUTH_USER_MODEL, on_delete=models.CASCADE)
    expiration = models.DateField()
    earned = models.DateField(default=timezone.now)

    def __str__(self):
        return "{}  - {}".format(self.training, self.trainee)

    @property
    def expired(self):
        return self.expiration < date.today()


class TrainingGroup(models.Model):
    group_name = models.CharField(max_length=64, default="")
    trainings = models.ManyToManyField(Training)

    def __str__(self):
        return self.group_name

    def check_user(self, user):
        log.info("Checking user {}".format(user))
        for training in self.trainings.all():
            ut_count = UserTraining.objects.filter(trainee=user, training=training).count() > 0
            if ut_count:
                ut = UserTraining.objects.get(trainee=user, training=training)
                if ut.expired:
                    return False
                else:
                    return True
            else:
                return False

resource-website/trainings/views.py
import os
import io
import csv

import logging

import pytz
from django.shortcuts import render
from django.shortcuts import redirect

from django.http import HttpResponseRedirect
from django.shortcuts import render, redirect
from django.http import HttpResponse
from django.urls import reverse
from django.utils import timezone

from django.http import HttpResponse
from django.http import FileResponse
from django.http import Http404

from social_django.utils import load_strategy
from django.contrib.auth.decorators import login_required, user_passes_test, permission_required
from django.core.exceptions import PermissionDenied

from .models import *

from .render import Render
from django.views.generic import View

from tests.models import Test


@login_required(login_url='/login/google-oauth2/')
def view_index(request):
    user_trainings = UserTraining.objects.filter(trainee=request.user)
    available_trainings = Training.objects.all()

    context = {
        'user_trainings': user_trainings,
        'available_trainings': available_trainings
    }
    return render(request, 'trainings/index.html', context)


@login_required(login_url='/login/google-oauth2/')
def view_certificate(request, user_training_id):
    usertraining = UserTraining.objects.get(pk=user_training_id)
    trainee = usertraining.trainee

    certificate = usertraining.training.certificate
    name = usertraining.training.certificate.name
    template = usertraining.training.certificate.html_template
    preimages = CertificateImage.objects.filter(certificate=certificate)
    images = []
    for image in preimages:
        images.append(image.image.path)

    params = {
        'usertraining': usertraining,
        'trainee': trainee,
        'images': images,
        'request': request
    }
    return Render.render(certificate.html_template.path, params)


@login_required(login_url='/login/google-oauth2/')
def view_training_details(request, training_id):
    training = Training.objects.get(pk=training_id)
    tests = Test.objects.filter(trainings=training)

    context = {
        'training': training,
        'tests': tests,
    }
    return render(request, 'trainings/details.html', context)


@login_required(login_url='/login/google-oauth2/')
def view_training_group_details(request):
    user_trainings = UserTraining.objects.filter(trainee=request.user)
    available_trainings = Training.objects.all()
    all_training_groups = TrainingGroup.objects.all()
    user_training_groups = []

    for group in TrainingGroup.objects.all():
        if group.check_user(request.user):
            user_training_groups.append(group)



    context = {
        'user_trainings': user_trainings,
        'available_trainings': available_trainings,
        'all_training_groups': all_training_groups,
        'user_training_groups': user_training_groups,
    }
    return render(request, 'trainings/tgcheck.html', context)

resource-website/trainings/templates/trainings/base.html
{% extends 'base.html' %}

{% block brand %}
    <a class="navbar-brand" href="{% url 'trainings' %}"><i class="fas fa-hard-hat mr-3"></i>Trainings</a>
{% endblock %}

{%  block navbar_items %}

{% endblock %}

resource-website/trainings/templates/trainings/details.html
{% extends 'trainings/base.html' %}

{% block title %} | Trainings {% endblock %}

{% block content %}
  <a href="{% url 'trainings' %}" class="btn btn-link float-left text-dark">
    <i class="fa fa-arrow-left mr-2"></i>Trainings
  </a>
    <div class="container">
        <h1 class="m-3 text-center">{{ training.title }} details </h1>
        <div class="list-group">
            {% if training.description %}
                <div class="list-group-item d-flex align-items-center justify-content-between">
                    Description: {{ training.description }}
                </div>
            {% else %}
                <div class="list-group-item d-flex align-items-center justify-content-between">
                   No description is available for this training.
                </div>
            {% endif %}
            <h1 class="m-3 text-center">Tests that grant this training</h1>
            {% if perms.tests.take_test %}
                <div class="list-group">
                    {% for test in tests %}
                        <div class="list-group-item d-flex align-items-center justify-content-between">
                            <h5 class="mb-1">{{ test.name }}</h5>
                            <div class="d-flex flex-row">
                                <a href="{% url 'test_sessions' test_id=test.id %}" class="btn btn-primary" role="button">Sessions</a>
                                {% if perms.tests.take_test %}
                                    <a href="{% url 'edit_test' test_id=test.id %}" class="btn btn-secondary ml-3" role="button">Details</a>
                                {% endif %}
                            </div>
                        </div>
                    {% endfor %}
                </div>
            {% else %}
                <p>You don't have permission to view tests!</p>
            {% endif %}
            {% if perms.trainings.view_user_trainings %}
                <h1 class="m-3 text-center">Users with this training</h1>
                <div class="list-group">
                    {% for user_training in training.usertraining_set.all %}
                        <div class="list-group-item d-flex align-items-start justify-content-between">
                            <h5 class="mb-1">{{ user_training.trainee.first_name }} {{ user_training.trainee.last_name }}</h5>
                            <div class="list-group">
                                {% for attempt_training in user_training.attempttraining_set.all %}
                                    <div class="list-group-item d-flex align-items-center justify-content-between">
                                        <span class="mr-3">{{ attempt_training.attempt.submitted }}, {{ attempt_training.attempt.registration.session.test.name }}, {{ attempt_training.attempt.registration.session.name }}:</span>
                                        <span>{% widthratio attempt_training.attempt.grade 1 100 %}%</span>
                                    </div>
                                {% endfor %}
                            </div>
                        </div>
                    {% endfor %}
                </div>
            {% endif %}
        </div>
    </div>
{% endblock %}

resource-website/trainings/templates/trainings/index.html
{% extends 'trainings/base.html' %}

{% block title %} | Trainings {% endblock %}

{% block content %}
    <div class="container">
        <h1 class="m-3 text-center">Your Trainings</h1>
        <div class="list-group">
            {% for training in user_trainings %}          
                <div class="list-group-item d-flex flex-row align-items-center justify-content-between">  
                    <div class="d-flex flex-column">
                        <h5 class="mb-1">{{ training.training.title }}</h5>
                        {% if not training.expired %}
                            <p class="mb-0"></p>
                                Valid Until {{ training.expiration }}
                            </p>
                        {% else %}
                            <p class="mb-0"></p>
                                EXPIRED {{ training.expiration }}
                            </p>
                        {% endif %}
                    </div>
                    <div class="d-flex flex-row">
                        <a href="{% url 'training_details' training_id=training.training.id %}" class="btn btn-info ml-3" role="button">
                            Details
                        </a>
                        {% if not training.expired %}
                            <a href="{% url 'certificate' user_training_id=training.id %}" class="btn btn-primary ml-3" role="button">
                                Certificate
                            </a>
                        {% endif %}
                    </div>
                </div>
            {% empty %}
            <h4 class="text-center">You don't have any trainings</h4>
            {% endfor %}
        </div>
        <h1 class="m-3 text-center">All Trainings</h1>
        <div class="list-group">
            {% for training in available_trainings %}          
                <div class="list-group-item d-flex flex-row align-items-center justify-content-between">  
                    <div class="d-flex flex-column">
                        <h5 class="mb-1">{{ training.title }}</h5>
                    </div>
                    <div class="d-flex flex-row">
                        <a href="{% url 'training_details' training_id=training.id %}" class="btn btn-info ml-3" role="button">
                            Details
                        </a>
                    </div>
                </div>
            {% empty %}
            <h4 class="text-center">There are currently no trainings</h4>
            {% endfor %}
        </div>

    </div>
{% endblock %}

resource-website/trainings/templates/trainings/tgcheck.html
{% extends 'trainings/base.html' %}

{% block title %} | Training Group Details {% endblock %}

{% block content %}
    <div class="container">
        <h1 class="m-3 text-center">Your Trainings</h1>
        <div class="list-group">
            {% for training in user_trainings %}
                <div class="list-group-item d-flex flex-row align-items-center justify-content-between">
                    <div class="d-flex flex-column">
                        <h5 class="mb-1">{{ training.training.title }}</h5>
                        {% if not training.expired %}
                            <p class="mb-0"></p>
                                Valid Until {{ training.expiration }}
                            </p>
                        {% else %}
                            <p class="mb-0"></p>
                                EXPIRED {{ training.expiration }}
                            </p>
                        {% endif %}
                    </div>
                    <div class="d-flex flex-row">
                        <a href="{% url 'training_details' training_id=training.training.id %}" class="btn btn-info ml-3" role="button">
                            Details
                        </a>
                        {% if not training.expired %}
                            <a href="{% url 'certificate' user_training_id=training.id %}" class="btn btn-primary ml-3" role="button">
                                Certificate
                            </a>
                        {% endif %}
                    </div>
                </div>
            {% empty %}
            <h4 class="text-center">You don't have any trainings</h4>
            {% endfor %}
        </div>

        <h1 class="m-3 text-center">Your Active Training Groups</h1>
        <div class="list-group">
            {% for tg in user_training_groups %}
                <div class="list-group-item d-flex flex-row align-items-center justify-content-between">
                    <div class="d-flex flex-column">
                        <h5 class="mb-1">{{ tg.group_name }}</h5>
                    </div>
                </div>
            {% empty %}
            <h4 class="text-center">You are not in any training groups</h4>
            {% endfor %}
        </div>

        <h1 class="m-3 text-center">All Training Groups</h1>
        <div class="list-group">
            {% for training in all_training_groups %}
                <div class="list-group-item d-flex flex-row align-items-center justify-content-between">
                    <div class="d-flex flex-column">
                        <h5 class="mb-1">{{ training.group_name }}</h5>
                    </div>
                </div>
            {% empty %}
            <h4 class="text-center">There are currently no trainings</h4>
            {% endfor %}
        </div>

    </div>
{% endblock %}